-- Name: EAS_AddSpecialization
-- Author: Chissel

g_easUtils = {}
g_easSettingsMenuExtension = {}

local function init()
    source(Utils.getFilename("src/EAS_Utils.lua", g_currentModDirectory))
    source(Utils.getFilename("src/EAS_AnimalsMenuExtension.lua", g_currentModDirectory))
    source(Utils.getFilename("src/EAS_SettingsMenuExtension.lua", g_currentModDirectory))
    source(Utils.getFilename("src/EAS_AddMoneyEvent.lua", g_currentModDirectory))
    source(Utils.getFilename("src/EAS_UpdateOvercrowdingStateEvent.lua", g_currentModDirectory))
    source(Utils.getFilename("src/EAS_AnimalsCanDieStateEvent.lua", g_currentModDirectory))
    source(Utils.getFilename("src/EAS_SyncSettingsEvent.lua", g_currentModDirectory))
    source(Utils.getFilename("src/EAS_SyncHusbandriesEvent.lua", g_currentModDirectory))
    g_easUtils = EAS_Utils()

    local easAnimalsMenuExtension = EAS_AnimalsMenuExtension
    easAnimalsMenuExtension:init()

    g_easSettingsMenuExtension = EAS_SettingsMenuExtension
    g_easSettingsMenuExtension:init()

    if g_placeableSpecializationManager:getSpecializationByName("EnhancedAnimalSystem") == nil then
        g_placeableSpecializationManager:addSpecialization("EnhancedAnimalSystem", "EnhancedAnimalSystem", Utils.getFilename("src/EnhancedAnimalSystem.lua", g_currentModDirectory), nil)
    end

    for placeableType, placeable in pairs(g_placeableTypeManager:getTypes()) do
        if SpecializationUtil.hasSpecialization(PlaceableHusbandryAnimals, placeable.specializations) then
            g_placeableTypeManager:addSpecialization(placeableType, "EnhancedAnimalSystem")
        end
    end

    g_easUtils:logText("EAS_AddSpecialization init done")
end

init()