-- Name: EAS_SyncHusbandriesEvent
-- Author: Chissel

EAS_SyncHusbandriesEvent = {}
local EAS_SyncHusbandriesEvent_mt = Class(EAS_SyncHusbandriesEvent, Event)

InitEventClass(EAS_SyncHusbandriesEvent, 'EAS_SyncHusbandriesEvent')

function EAS_SyncHusbandriesEvent.emptyNew()
    return Event.new(EAS_SyncHusbandriesEvent_mt)
end

function EAS_SyncHusbandriesEvent.new()
    return EAS_SyncHusbandriesEvent.emptyNew()
end

function EAS_SyncHusbandriesEvent:readStream(streamId, connection)
    self:run(connection)
end

function EAS_SyncHusbandriesEvent:writeStream(streamId, connection)
end

function EAS_SyncHusbandriesEvent:run(connection)
    g_easUtils:logText("Receive EAS_SyncHusbandriesEvent")

    if not connection:getIsServer() then
        for _, husbandry in ipairs(g_currentMission.husbandrySystem.clusterHusbandries) do
            local state = husbandry.placeable.allowOvercrowding or false
            connection:sendEvent(EAS_UpdateOvercrowdingStateEvent.new(husbandry.placeable, state))
            g_easUtils:logText("Sync husbandry with id: "..husbandry.placeable.id)
        end
    end
end
